import java.io.*;

public class menu {
  BufferedReader in = new BufferedReader( new InputStreamReader( System.in ) );

  // public constants returned by getBaseChoice().
  public final static int HELP = 0;
  public final static int QUIT = 1;
  public final static int NEW = 2;
  public final static int ACTION = 3;

  // public constants returned by getObjectChoice().
  public final static int POINT = 10;
  public final static int LINE = 11;
  public final static int CIRCLE = 12;
  public final static int TEXT = 13;

  // public constants returned by getActionChoice().
  public final static int MOVE = 20;
  public final static int MOVETO = 21;
  public final static int SHOW = 22;
  public final static int HIDE = 23;

  // public constants used by all get * Choice() functions.
  // indicates user wants to go back to previous menu.
  public final static int BACK = -2;
  // the users choice wasn't valid.
  public final static int BAD_CHOICE = -1;

  // functions to place the text of the menus.
  public void showBaseMenu() { System.out.print("(h)elp (q)uit (n)ew object (a)ctions "); }
  public void showObjectMenu() { System.out.print("(p)oint (l)ine (c)ircle (t)ext (.)back "); }
  public void showActionMenu() { System.out.print("(m)ove (M)oveTo (s)how (h)ide (.)back "); }

  // ask for user choice only enables the base menu choices.
  public int getBaseChoice() {
    try {
      String choice = in.readLine();
    if( choice.equals("h") ) return HELP;
    if( choice.equals("q") ) return QUIT;
    if( choice.equals("n") ) return NEW;
    if( choice.equals("a") ) return ACTION;
    } catch( IOException e ) {
      System.out.println("Sorry Input is not available. No InputStream found.");
      }
    return BAD_CHOICE;
  }

  // asks for user choice on the object menu.
  public int getObjectChoice() {
    try {
      String choice = in.readLine();
    if( choice.equals("p") ) return POINT;
    if( choice.equals("l") ) return LINE;
    if( choice.equals("c") ) return CIRCLE;
    if( choice.equals("t") ) return TEXT;
    if( choice.equals(".") ) return BACK;
    } catch( IOException e ) {
      System.out.println("Sorry Input is not available. No InputStream found.");
      }
    return BAD_CHOICE;
  }

  // asks for user choice on the action menu.
  public int getActionChoice() {
    try {
      String choice = in.readLine();
    if( choice.equals("m") ) return MOVE;
    if( choice.equals("M") ) return MOVETO;
    if( choice.equals("s") ) return SHOW;
    if( choice.equals("h") ) return HIDE;
    if( choice.equals(".") ) return BACK;
    } catch( IOException e ) {
      System.out.println("Sorry Input is not available. No InputStream found.");
      }
    return BAD_CHOICE;
  }

  // questions for text.
  public String getStr(String strQuestion) {
    String ret;

    System.out.print(strQuestion);
    try {
      ret = in.readLine();
    } catch( IOException e ) {
      System.out.println("Sorry Input is not available. No InputStream found.");
//Exception ausgeben.
      return "";
      }
    return ret;
  }


  // questions for integer.
  public int getInt(String strQuestion, boolean neg) {

    String choice;
    int ret = 0;
    boolean NaN = true;

    while( NaN ) {
      try {
        try {
          System.out.print(strQuestion);
          // read input
          choice = in.readLine();
        } catch( IOException e ) {
          System.out.println("Sorry Input is not available. No InputStream found.");
//Exception ausgeben.
          return 0;
          }

        // try converting to integer.
        ret = (Integer.valueOf(choice)).intValue();

        // wenn negative Zahlen erlaubt sind ...
        if( neg ) NaN = false;
        // falls nicht erlaubt
        else {
          // ist Zahl positiv oder Null? ...
          if ( ret >= 0 ) NaN = false;
          // wenn nicht wiederhole ...
          else {
            NaN = true;
            System.out.print("enter a positiv number\t");
          }
        }

      } catch( NumberFormatException e ) {
        // not a number.
        NaN = true;
        System.out.print("enter an integer\t");
        }

    }// repeat

    // return the integer.
    return ret;
  }

// eingabe eines beliebigen textes

}

