import java.io.*;
import java.lang.Math;

class screen {
  // array to draw in.
  private char[][] buffer;
  private int width = 0;
  private int height = 0;

  // constructor
  screen( int new_width, int new_height ) {
    if ( new_width >= 0 ) width = new_width;
    if ( new_height >= 0 ) height = new_height;
    buffer = new char[width][height];
  }

  // set a char specified by color in the array; checking the boundaries.
  private boolean putPixel( int x, int y, char color ) {
    if ( x<0 || y<0 || x>width || y>height ) return false;
    buffer[x][y] = color;
    return true;
  }


  private int round( double d ) {
    d *= 10;
    d += 5;
    d /= 10;
    return (int)d;
  }

  // performing drawing the objects.
  public void draw( Object obj ) {
    if ( obj instanceof point ) {
      point p = (point)obj;
      if( p.visible == true ) putPixel(p.getX(), p.getY(), p.color);
    }
    if (obj instanceof circle ) {
      // System.out.println("drawing circle");
      circle c = (circle)obj;
      if( c.visible == true ) {
        for( int alpha = 0; alpha <= 359; alpha++ ) {
          putPixel(c.getX() + round(c.getRadius()*Math.cos(alpha)), c.getY() + round(c.getRadius()*Math.sin(alpha)), c.color);
        }
      }
    }
    if ( obj instanceof text ) {
      text t = (text)obj;
      if( t.visible == true ) {
        for( int i=0; i< t.getText().length(); i++ ) {
          putPixel(t.getX() + i , t.getY(), t.getText().charAt(i) );
        }
      }
    }
    if ( obj instanceof line ) {
      line l = (line)obj;
      if( l.visible == true ) {

        double m;
        int y = 0;
        int x = 0;

        int gX = l.getX();
        int gY = l.getY();
        int dx = l.getDx();
        int dy = l.getDy();


        if (dx != 0 && dy != 0)  {
          m = (double)dy / (double)dx;

          // Wenn Steigung betragsmsig kleiner als 1
          if (m<=1 && m>=-1 ) {
            // Wenn dx negativ d.h der 2. Punkt tatschlich weiter links ist
            if( dx<0 ) {
              // Punkte vertauschen
              // moveto( getX()+dx, getY() +dy );
              gX += dx;
              gY += dy;
              dx = -dx;
              dy = dy;
            }
            for (int i=gX; i <= gX+dx; i++) {
              y = (int)( m*(i-gX) + gY);
              putPixel(i, y, l.color);
            }
          }

          // Betragsmsig hhere Steigung als 1
          if (m>1 || m<-1) {
            if( dy<0 ) {
              // Punkte vertauschen weil Punkt 2 tatschlich hher als Punkt 1
              // moveto( getX()+dx, getY() +dy );
              gX += dx;
              gY += dy;
              dx = -dx;
              dy = -dy;
            }

            m = (double)dx / (double)dy;
            // System.out.println(" case 1" );
            for (int i=gY; i <= gY + dy; i++) {
              x = (int)( m*(i-gY) + gX);
              // gc.setPoint(x,i);
              putPixel(x, i, l.color);
            }
          }
        } else {

          if( dx == 0 ) {
            if( dy<0 ) {
              // Punkte vertauschen weil Punkt 2 tatschlich hher als Punkt 1
              // moveto( getX()+dx, getY() +dy );
              gX += dx;
              gY += dy;
              dy = -dy;
            }
            for (int i=gY; i <= gY+dy; i++) {
              x = gX;
              // gc.setPoint(x,i);
              putPixel(x, i, l.color);

            }
          }
          if( dy == 0 ) {
            // Wenn dx negativ d.h der 2. Punkt tatschlich weiter links ist
            if( dx<0 ) {
              // Punkte vertauschen
              // moveto( getX()+dx, getY() +dy );
              gX += dx;
              gY += dy;
              dx = -dx;
            }
            for (int i=gX; i <= gX + dx; i++) {
              y = gY;
              // gc.setPoint(i,y);
              putPixel(i, y, l.color);
            }
          }
        }
      }
    }

// line
  }

  // clearing the buffer with the specified char.
  public void clear( char color ) {
    for( int i=0; i<height; i++ ) {
      for( int j=0; j<width; j++ ) {
        putPixel(j,i,color);
      }
    }
  }

  // copying the buffer to System.out. using print method.
  public void show() {
    for( int i=height -1; i>= 0; i-- ) {
      for( int j=0; j<width; j++ ) {
        System.out.print(buffer[j][i]);
      }
      System.out.print("\n");
    }
  }

}